# nextcloud-helper

A bunch of tools I use to make Nextcloud work smoother in my configuration.

The most critical ones are:

**Hardlinks**

* A tool that looks for my favourite games installed locally and uses hardlinks to connect them to my Nextcloud hardlinks folder, so all their settings/savegames/whatever local data gets automatic cloud storage.
* If I set up a new computer, it automatically gets all my save games and mods and settings installed because they're already downloaded through Nextcloud, and it will just hardlink them into the right places, nice!

**Conflicts**

* Nextcloud seems really dumb at detecting imaginary conflicts sometimes, I don't know why it seems to get so confused.
* Even when the conflicts are legitimate, resolving them is unneccessarily tedious when there are potentially thousands of conflicted files (say, in a Minecraft world for example)
* This tool cleans up conflicts in a more unobtrusive way, providing a few different options for conflict resolution:
* * Use the server version automatically
* * Restore the local version (Nextcloud always treats the server as authoritative and renames local conflicts ^(confirm?) )
* * Use the last modified date to determine which file is a better choice (often one of the "conflicted" files is hours, days or even months old which makes it obviously not the right one)

**Program Locking**

* Sometimes it really sucks (and causes a lot of conflicts as noted above) when two computers are both running a program that is fighting over certain files.
* Often these conflicting files are ones you don't even care about, like logfiles
* Without any clear way to ignore certain files from Nextcloud, I settled on the next best alternative, which is to refuse to allow certain programs to run on two computers at once.
* It does this in a not-foolproof (and easily bypassable) way by creating a file with the name of the computer that is running it, and not running automatically if that file exists, and telling me the name of the computer it's running on so I can shut it down there first.
* Currently in use for Calibre Portable, PrusaSlicer, Minecraft, and OpenXCOM
* PrusaSlicer's launcher does some neat tricks with file associations too which requires an exe called SetUserFTA because Microsoft is an asshole and loathes people setting up their own computers to do what they want.

Also includes some random tools I use for syncing or modding  various data in games mainly because I never figured out anywhere better to put them.